## SP500_demo_01.R 
## To run ==> source('~/Dropbox/SP500_demo_01.R', echo=T)

## ----------------------------------------
## Pause (sleep) for specified number of seconds
testit <- function(x)
{
    p1 <- proc.time()
    Sys.sleep(x)
    proc.time() - p1 # The cpu usage should be negligible
}

## --------------------------------------------------

# Don't forget to install the necessary packages
# for example, install.packages('quantmod')

# Required package is quantmod
require(quantmod)

# Not interested in all columns, just two 
# Get S&P closing prices and corresponding daily volume since 1/1/1950 
sp500 <- getSymbols("^GSPC", auto.assign = FALSE, from="1950-01-01")[, (4:5)]

# Change column names to something more understandable
colnames(sp500) <- c("SP500", "SPvolume")

tail(sp500)

## Pause
testit(10)     ## Pause will last this number of seconds

# plot SP500
plot(sp500$SP500, main="SP500 Index (linear scale)")

## Pause
testit(15)     ## Pause will last this number of seconds

# plot SP500 using a log scale
plot(sp500$SP500, main="SP500 Index (log scale)", log="y")

## Pause
testit(12)     ## Pause will last this number of seconds

# plot SP500 using a log scale
plot(tail(sp500$SP500, 10080), main="SP500 Index (last 40 years)", log="y")

## Pause
testit(7)     ## Pause will last this number of seconds

# plot SP500 using a log scale
plot(tail(sp500$SP500, 7560), main="SP500 Index (last 30 years)", log="y")

## Pause
testit(7)     ## Pause will last this number of seconds

# plot SP500 using a log scale
plot(tail(sp500$SP500, 5040, log="y"), main="SP500 Index (last 20 years)")

## Pause
testit(7)     ## Pause will last this number of seconds

plot(tail(sp500$SP500, 2520, log="y"), main="SP500 Index (last 10 years)")

## Pause
testit(7)     ## Pause will last this number of seconds

plot(tail(sp500$SP500, 1260, log="y"), main="SP500 Index (last 5 years)")

## Pause
testit(7)     ## Pause will last this number of seconds

plot(tail(sp500$SP500, 756, log="y"), main="SP500 Index (last 5 years)")

## Pause
testit(7)     ## Pause will last this number of seconds

plot(tail(sp500$SP500, 252, log="y"), main="SP500 Index (last 12 months)")

## Pause
testit(5)     ## Pause will last this number of seconds

plot(tail(sp500$SP500, 126, log="y"), main="SP500 Index (last 6 months)")

## Pause
testit(5)     ## Pause will last this number of seconds

plot(tail(sp500$SP500, 63, log="y"), main="SP500 Index (last 3 months)")

summary(sp500)

tail(sp500, 15)

# Calculate the S&P percentage below the all time high
SPdnPCT <-  100 * (1-(tail(sp500$SP500, 1)) / max(sp500$SP500))
# round(SPdnPCT, digits=2)

string1 <- "The S&P 500 Index is now down"

string2 <- "percent from the all time high." 

#print(string1); print(round(SPdnPCT, digits=3)); print(string2)

## paste examples:
#paste("A", 1:6, sep = "")
#     stopifnot(identical(paste ("A", 1:6, sep = ""),
#                         paste0("A", 1:6)))
#     paste("Today is", date())
print(paste(string1, round(SPdnPCT, digits=2), string2)) 



# ---------------
